<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleHeadway StructType
 * @subpackage Structs
 */
class VehicleHeadway extends AbstractStructBase
{
    /**
     * The distanceGap
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $distanceGap;
    /**
     * The distanceHeadway
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $distanceHeadway;
    /**
     * The vehicleHeadwayExtension
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtensionType
     */
    public $vehicleHeadwayExtension;
    /**
     * Constructor method for VehicleHeadway
     * @uses VehicleHeadway::setDistanceGap()
     * @uses VehicleHeadway::setDistanceHeadway()
     * @uses VehicleHeadway::setVehicleHeadwayExtension()
     * @param float $distanceGap
     * @param float $distanceHeadway
     * @param \StructType\ExtensionType $vehicleHeadwayExtension
     */
    public function __construct($distanceGap = null, $distanceHeadway = null, \StructType\ExtensionType $vehicleHeadwayExtension = null)
    {
        $this
            ->setDistanceGap($distanceGap)
            ->setDistanceHeadway($distanceHeadway)
            ->setVehicleHeadwayExtension($vehicleHeadwayExtension);
    }
    /**
     * Get distanceGap value
     * @return float|null
     */
    public function getDistanceGap()
    {
        return $this->distanceGap;
    }
    /**
     * Set distanceGap value
     * @param float $distanceGap
     * @return \StructType\VehicleHeadway
     */
    public function setDistanceGap($distanceGap = null)
    {
        $this->distanceGap = $distanceGap;
        return $this;
    }
    /**
     * Get distanceHeadway value
     * @return float|null
     */
    public function getDistanceHeadway()
    {
        return $this->distanceHeadway;
    }
    /**
     * Set distanceHeadway value
     * @param float $distanceHeadway
     * @return \StructType\VehicleHeadway
     */
    public function setDistanceHeadway($distanceHeadway = null)
    {
        $this->distanceHeadway = $distanceHeadway;
        return $this;
    }
    /**
     * Get vehicleHeadwayExtension value
     * @return \StructType\ExtensionType|null
     */
    public function getVehicleHeadwayExtension()
    {
        return $this->vehicleHeadwayExtension;
    }
    /**
     * Set vehicleHeadwayExtension value
     * @param \StructType\ExtensionType $vehicleHeadwayExtension
     * @return \StructType\VehicleHeadway
     */
    public function setVehicleHeadwayExtension(\StructType\ExtensionType $vehicleHeadwayExtension = null)
    {
        $this->vehicleHeadwayExtension = $vehicleHeadwayExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleHeadway
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
